﻿Type=StaticCode
Version=1.70
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	Dim xx As String
End Sub

'Executes the query and returns the result as a list of arrays.
'Each item in the list is a strings array.
Sub ExecuteMemoryTable1(xSQL As SQL, xQuery As String) As List
	Dim cur As Cursor
	cur = xSQL.ExecQuery(xQuery)
	'Log("ExecuteMemoryTable: " & Query)
	Dim table As List
	table.Initialize
	cur.Position = 0
'	Dim values(cur.ColumnCount) As String
	For row = 0 To cur.RowCount - 1
		cur.Position = row
		Dim values(cur.ColumnCount) As String
		For col = 0 To cur.ColumnCount - 1
			values(col) = cur.GetString2(col)
		Next
		table.Add(values)
	Next
	cur.Close
	Return table
End Sub

Sub InitDB
	main.pNuovoDB=False
	If File.Exists(main.DirDB, main.pNomeDB)=False Then
		main.pNuovoDB=True
	End If	
	main.SQL1.Initialize(main.DirDB, main.pNomeDB, True)
	Dim s1 As String
	For t1=0 To main.pNrTabelle
		main.pTabellaOpz=Regex.Split(",", main.pFields(t1,0))
'		s1="DROP TABLE IF EXISTS "&main.pTabellaOpz(0)
'		main.SQL1.ExecNonQuery(s1)
		main.cur=main.SQL1.ExecQuery("select * from sqlite_master where type='table' and tbl_name='"&main.pTabellaOpz(0)&"'")
		If main.cur.RowCount=0 Then
			s1="CREATE TABLE IF NOT EXISTS "&main.pTabellaOpz(0)&" ("
			For t2=1 To main.pTabellaOpz(3)
				main.pFieldsOpz=Regex.Split(",", main.pFields(t1,t2))
				If t2>1 Then
					s1=s1&", "
				End If
				s1=s1&main.pFieldsOpz(0)&" "&main.pFieldsOpz(2)
				s1=s1&" DEFAULT "
				If main.pFieldsOpz(2)="TEXT" Then
					s1=s1&"''"
				Else
					s1=s1&"0"
				End If
				If main.pFieldsOpz(5)="P" Then
					s1=s1&" PRIMARY KEY"
				End If
			Next
			s1=s1&")"
			main.SQL1.ExecNonQuery(s1)
			If main.pTabellaOpz(0)="arcparam" Then
				' si inserisce subito il record in arcparam per valorizzare la versione del db=1
				main.SQL1.ExecNonQuery("insert into arcparam (keygen, versionedb) values ('GEN1', 1)")
			End If
		End If
		main.cur.close		
	Next
End Sub

Sub UpdateDB
	' controllo aggiornamento db
	main.cur=main.SQL1.ExecQuery("select * from arcparam where keygen='GEN1'")
	Dim oldVersioneDB As String
	main.cur.Position=0
	oldVersionedb=main.cur.GetInt("versionedb")
	main.cur.Close
	If main.pVersioneDB<>oldVersioneDB Then
		If main.pNuovoDB=False Then   ' l'update del db deve essere fatto solo il db NON è nuovo
			Msgbox("IL DATABASE DEVE ESSERE AGGIORNATO", "TTT")		
			For nragg=oldVersioneDB+1 To main.pVersioneDB
				For col=0 To main.pNrRigheAgg
					sq=main.pUpdateDB(nragg, col)
					If sq<>"" Then
						main.SQL1.ExecNonQuery(sq)
					End If
				Next
			Next
		End If
		main.SQL1.ExecNonQuery("UPDATE arcparam SET versionedb="&main.pVersioneDB)
	End If	
End Sub

'Delete tabella da database
Sub DropTable(xSQL As SQL, TableName As String)
	Dim query As String
	query = "DROP TABLE IF EXISTS [" & TableName & "]"
	'	Log("DropTable: " & query)
	xSQL.ExecNonQuery(query)
End Sub

Sub NomeTabella(nTab As Int) As String
	main.pTabellaOpz=Regex.Split(",", main.pFields(nTab,0))
	Return main.pTabellaOpz(0)
End Sub

Sub AlignDx(Text As String, Lenght As Int, WithChar As String, WithTrim As Boolean) As String
	' allineamento a destra con WithChar a sx
	If WithTrim=True Then Text=Text.Trim
	For t=1 To Lenght-Text.Length
		Text=WithChar&Text
	Next
	Return Text
End Sub

Sub AlignSx(Text As String, Lenght As Int, WithChar As String, WithTrim As Boolean) As String
	' allineamento a sinistra con WithChar a dx
	If WithTrim=True Then Text=Text.Trim
	For t=1 To Lenght-Text.Length
		Text=Text&WithChar
	Next
	Return Text
End Sub

Sub NumDecimal(numero As Double, ndecimal As Int)
	' ritorna numero con ndecimal
	Dim numint As Int : numint=numero
	If ndecimal=0 Then Return numint
'	nd=NumberFormat((numero-numint)&"0000000000", 0, ndecimal)
	nd=NumberFormat((numero-numint), 0, ndecimal)
	Dim ndd As Double : ndd=nd*Power(10, ndecimal)
	Return numint&"."&left(ndd&"0000000000", ndecimal)
End Sub

Sub Left(Text As String, Length As Int)As String 
	If Length>Text.Length Then Length=Text.Length 
	Return Text.SubString2(0, Length)
End Sub

Sub Right(Text As String, Length As Long) As String
	If Length>Text.Length Then Length=text.Length 
	Return Text.SubString(Text.Length-Length)
End Sub

Sub Mid(Text As String, Start As Int, Length As Int) As String 
	' ritorna la stringa Text da Start per Lenght lunghezza
	If Text="" Then 
		Return ""
	End If
	Return Text.SubString2(Start-1, Start-1+Length)
End Sub

Sub Substr(Text As String, Start As Int, Length As Int) As String 
	' come mid, per compatibilità con vfp) : ritorna la stringa Text da Start per Lenght lunghezza
	Return Text.SubString2(Start-1, Start+Length-1)
End Sub

Sub At(Text As String, InStr As String) As String
	' ritorna la posizione del carattere Text presente in InStr (-1 = non presente)
	Return Text.IndexOf(InStr)
End Sub

Sub Stuff(Text As String, InStr As String, WinStr As String) As String  
	'Stuff("Variable to stuff", "New text to insert", "Text to drop & replace")
	Return Left(Text,At(Text, Winstr)) & Instr & Right(Text, (Len(Text)-At(Text, Winstr))-Len(WinStr))
End Sub

Sub Trim(Text As String) As String
	' per compatibilità
	Return Text.Trim
End Sub

Sub Len(Text As String) As String
	' per compatibilità
	Return text.Length
End Sub

Sub Ltrim(Text As String) As String
	' ritorna stringa senza spazi a sx
	Do While Left(Text, 1) =" "
		Text = Right(text, len(Text)-1)
	Loop
	Return Text
End Sub

Sub Rtrim(Text As String) As String
	' ritorna stringa senza spazi a dx
	Do While Right(Text, 1) =" "
		Text = Left(Text, len(Text)-1)
	Loop
	Return Text
End Sub

Sub Space(nSpaces As Int) As String
	rs = ""
	Do While Len(rs) < nSpaces
		rs = rs & " "
	Loop
	Return rs
End Sub

Sub Empty(Text As String) As Boolean
	text = Trim(text)
	If text.Length < 1 Then
		Return True
	Else
		Return False
	End If	
End Sub

Sub addAND(Text As String) As String
	If text.Length > 0 Then
		Return " AND "
	End If
	Return ""
End Sub

Sub addR(Text As String) As String
	If text.Length > 0 Then
		Return " OR "
	End If
	Return ""
End Sub

Sub Val(Text As String) As String
	Do While IsNumber(Right(text,1))=False Then
		If len(text) > 0 Then
			text=Left(text, Len(text)-1)
		Else
			Exit
		End If	
	Loop
	If len(text) > 0 Then 
		Return text + 0
	Else
		Return 0
	End If	
End Sub

Sub iif(Text As String, Text1 As String, Text2 As String) As String
	If Text = True Then Return Text1 Else Return Text2
End Sub

Sub Sleep(ms As Long)
Dim now As Long
	If ms > 4000 Then ms = 4000   'avoid application not responding error
	now=DateTime.Now
	Do Until (DateTime.Now>now+ms)
	  DoEvents
	Loop
End Sub

Sub RndChrGen(HowMany As Int, CT As String, da As Int, a As Int) As String
	' ritorna stringa di caratteri causali :
	' HowMany = nr.caratteri o cifre : se ct=N, HowMany=1
	' ct = "Q" : lettere alfanumerici
	' ct = "M" : lettere maiuscole
	' ct = "m" : lettere minuscole
	' ct = "N" : numeri da... a...
	' da.. a... : numero compreso tra da e a
	If CT = "Q" Then
		L=65 : U=122
	Else If CT="M" Then
		L=65 : U=90
	Else If CT="m" Then
		L=97 : U=122
	Else 
		Return Rnd(da, a)
	End If
	c=""
	For x=1 To HowMany				
		nc = Rnd(L, U)
		If nc>=91 AND nc<=96 Then 
		Else
			c = c & Chr(nc)
		End If
	Next
	Return c
End Sub

Sub Localize(Azione)
	' acquisizione dati dalla localizzazione
	main.locale.Initialize2(main.Lingua)
	main.trans.Initialize2(File.DirAssets, "lng", main.Lingua)
	main.dt.Initialize
	main.dt.Lenient = False
End Sub

Sub today(formato As String) As String
	' ritorna la data del sistema nel formato richiesto
	fd=DateTime.DateFormat
	If formato<>"" Then 
		DateTime.DateFormat=formato
	End If
	oggi=DateTime.date(DateTime.Now)
	DateTime.DateFormat=fd
	Return oggi
End Sub

Sub ConvData(xdata As String, daFormato As String, aFormato As String) As String
	' converte la data da un formato all'altro
	' daFormato - aFormato : almeno uno deve essere valorizzato, non possono essere entrambi vuoti
	' se daFormato o aFormato vuoto = formato default
	fd=DateTime.DateFormat
	If xdata="" Then
		Msgbox(main.trans.GetText("Sintassi ConvData errata : ")&CRLF&main.trans.GetText("Data errata"), main.NomePrg) 
		Return ""
	End If
'	If daFormato<>"" AND aFormato<>"" Then
'		Msgbox(main.trans.GetText("Sintassi ConvData errata : ")&CRLF&main.trans.GetText("Solo uno dei due parametri 'Formato' deve essere valorizzato"), main.NomePrg) 
'		Return ""
'	End If
	If daFormato="" AND aFormato="" Then
		Msgbox(main.trans.GetText("Sintassi ConvData errata : ")&CRLF&main.trans.GetText("Almeno uno dei due parametri 'Formato' deve essere valorizzato"), main.NomePrg) 
		Return ""
	End If
	If daFormato<>"" AND aFormato<>"" Then
		DateTime.DateFormat=daFormato
		xticks=DateTime.DateParse(xdata)
		DateTime.DateFormat=aFormato
		ydata=DateTime.Date(xticks)
		DateTime.DateFormat=fd
		Return ydata
	End If
	If daFormato<>"" Then
		DateTime.DateFormat=daFormato
		xticks=DateTime.DateParse(xdata)
		DateTime.DateFormat=fd
		Return DateTime.Date(xticks)
	End If
	If aFormato<>"" Then
		xticks=DateTime.DateParse(xdata)
		DateTime.DateFormat=aFormato
		xdata1=DateTime.Date(xticks)
		DateTime.DateFormat=fd
		Return xdata1
	End If
End Sub

Sub ChiamaND(Testo As String, nrCifre As Int, Numero As Int, decimali As Int, MostraSegno As Boolean) As String
	' richiama la libreria Dialog... e ritorna il numero digitato
	Dim nd As NumberDialog
	nd.Digits = nrCifre
	nd.Number = Numero
	nd.Decimal = decimali
	nd.ShowSign = MostraSegno
	ret = nd.Show(Testo, main.trans.GetText("OK"), main.trans.GetText("NO"), "", Null)	
	If ret=-1 Then 
			Return nd.Number
		Else
			Return Numero
	End If
End Sub

Sub HttpToDbFromFile(inFile As InputStream, TipoOpe As String, tabella As Int, fdrop As Boolean, fcreate As Boolean, fdeleteall As Boolean) As Int
	Dim contaeec As Int : contarec=0
	xNomeTabella=NomeTabella(tabella)
	main.TextReader1.Initialize(inFile)
	Dim line As String
	Dim mysql_record() As String
	line = main.TextReader1.ReadLine
	If line<>Null AND Empty(line)=False Then
		mysql_record = Regex.Split(TipoOpe, line)
		If fdrop=True Then
			main.SQL1.ExecNonQuery(mysql_record(1)) ' drop table se necessario : clausola 'if exists' presente nel comando
		End If
	End If
	line = main.TextReader1.ReadLine
	If line<>Null AND Empty(line)=False Then
		mysql_record = Regex.Split(TipoOpe, line)
		If fcreate=True Then
			main.SQL1.ExecNonQuery(mysql_record(1)) ' create table : clausola 'if exists' presente nel comando
		End If
	End If
	If fdeleteall=True Then
		main.SQL1.ExecNonQuery("delete from "&NomeTabella(tabella)) ' delete all
	End If
	main.SQL1.BeginTransaction
	Try
		line = main.TextReader1.ReadLine
		Do While line <> Null
			contarec=contarec+1
			mysql_record = Regex.Split(TipoOpe, line)
			main.SQL1.ExecNonQuery(mysql_record(1))
			line = main.TextReader1.ReadLine
		Loop
		main.SQL1.TransactionSuccessful
	Catch
'		Log(LastException.Message)
		Msgbox(LastException.Message, main.NomePrg)
	End Try
	main.SQL1.EndTransaction
	main.TextReader1.Close 
	Return contarec
End Sub

Sub HttpToDbFromString(inString As String, TipoOpe As String, tabella As Int, fdrop As Boolean, fcreate As Boolean, fdeleteall As Boolean) As Int
	Dim contaeec As Int : contarec=0
	xNomeTabella=NomeTabella(tabella)
	Dim mysql_record() As String
	mysql_record = Regex.Split(TipoOpe, inString)
	If mysql_record.Length>1 Then
		If fdrop=True Then
			main.SQL1.ExecNonQuery(mysql_record(1)) ' drop table se necessario : clausola 'if exists' presente nel comando
		End If
		If fcreate=True Then
			main.SQL1.ExecNonQuery(mysql_record(2)) ' create table : clausola 'if exists' presente nel comando
		End If
		If fdeleteall=True Then
			main.SQL1.ExecNonQuery("delete from "&NomeTabella(tabella)) ' delete all
		End If
		main.SQL1.BeginTransaction
		Try
			For t=3 To mysql_record.Length-1
				contarec=contarec+1
				main.SQL1.ExecNonQuery(mysql_record(t))
			Next
			main.SQL1.TransactionSuccessful
		Catch
			Msgbox(LastException.Message, main.NomePrg)
			'Log(LastException)
		End Try
		main.SQL1.EndTransaction
	Else

	End If
	Return contarec
End Sub
